<template>
  <div>
    <div @click="openDialog">
      <slot></slot>
    </div>
    <a-modal v-model="isDialogActive" centered :footer="null" :width="1100" :closeable="false">
      <div class="relative mb-8">
        <div class="absolute">
          <b-outline-action-button @click="closeDialog">Back</b-outline-action-button>
        </div>
        <div class="text-center">
          <t-h1 size="text-3xl" weight="bold">Personal Information</t-h1>
        </div>
      </div>
      <div class="text-center mb-6">
        <a-radio-group v-model="tab" button-style="solid">
          <a-radio-button value="general">General</a-radio-button>
          <a-radio-button value="history">History</a-radio-button>
          <a-radio-button value="nearby">Nearby</a-radio-button>
        </a-radio-group>
      </div>
      <div v-if="tab === 'general'" class="p-12 py-10">
        <general-person></general-person>
      </div>
      <div v-if="tab === 'history'" class="p-12 py-10">
        <historical-person></historical-person>
      </div>
      <div v-if="tab === 'nearby'" class="p-12 py-10">
        <nearby-person></nearby-person>
      </div>
    </a-modal>
  </div>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import { useBuilding } from '~/store/building'
import TH1 from '~/components/shared/typography/H1.vue'
import BOutlineActionButton from '~/components/shared/buttons/OutlineActionButton.vue'
import GeneralPerson from '~/components/person/GeneralPerson.vue'
import HistoricalPerson from '~/components/person/HistoricalPerson.vue'
import NearbyPerson from '~/components/person/NearbyPerson.vue'
import { IPassengerItem } from '~/contracts'

export default defineComponent({
  components: {
    GeneralPerson,
    HistoricalPerson,
    NearbyPerson,
    BOutlineActionButton,
    TH1,
  },
  props: {
    passenger: {
      type: Object as () => IPassengerItem,
      required: true
    },
  },
  setup() {
    const store = useBuilding()
    return { store }
  },
  data() {
    return {
      tab: 'general',
      isDialogActive: false,
    }
  },
  methods: {
    openDialog() {
      this.store.onSelectPassenger(this.passenger.id)
      this.isDialogActive = true
    },
    closeDialog() {
      this.isDialogActive = false
    },
  },
})
</script>
